/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
import isPrime from './prime.js';
import isLeapYear from './leap_year.js';
import arraySum from './array_sum.js';
import chessboardSpace from './chessboard.js';
import selectAStrings from './astrings.js';
import median from './median.js';

function assertEqual(x, y) {
  if (x === y) {
    console.log('.');
  } else {
    console.log('FAIL');
  }
}

// Prime numbers
console.log('Prime Numbers');
assertEqual(isPrime(3), true);
assertEqual(isPrime(1), true);
assertEqual(isPrime(4), false);
assertEqual(isPrime(2), true);
assertEqual(isPrime(5), true);
assertEqual(isPrime(6), false);
assertEqual(isPrime(7), true);
assertEqual(isPrime(8), false);

// Leap year
console.log('Leap Year');
assertEqual(isLeapYear(1900), false);
assertEqual(isLeapYear(1901), false);
assertEqual(isLeapYear(1902), false);
assertEqual(isLeapYear(1903), false);
assertEqual(isLeapYear(1904), true);
assertEqual(isLeapYear(2000), true);
assertEqual(isLeapYear(2004), true);

// Array sum
console.log('Array sum');
assertEqual(arraySum([3, 6, 9, 1, 8]), 27);
assertEqual(arraySum([]), 0);

// Chessboard
console.log('Chessboard');
assertEqual(chessboardSpace(16), 5);
assertEqual(chessboardSpace(65), 8);

// Select 'A' strings
console.log('A strings');
const array = ['apple', 'banana', 'ant', 'aardvark', 'panda'];
assertEqual(JSON.stringify(selectAStrings(array)), JSON.stringify(['apple', 'ant', 'aardvark']));
assertEqual(JSON.stringify(selectAStrings([])), JSON.stringify([]));

// Median
console.log('Median');
assertEqual(median([1, 3, 7, 9, 13]), 7);
assertEqual(median([1, 3, 7, 9, 13, 18]), 8);
assertEqual(median([1]), 1);
assertEqual(median([1, 2]), 1.5);
assertEqual(median([]), null);
