/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
import bubbleSort from './bubble_sort.js';
import { hasDuplicateValue as hasDuplicateValue1 } from './duplicates1.js';
import { hasDuplicateValue as hasDuplicateValue2 } from './duplicates2.js';
import { hasDuplicateValue as hasDuplicateValue3 } from './duplicates3.js';
import { hasDuplicateValue as hasDuplicateValue4 } from './duplicates4.js';
import greatestProduct from './greatest_product.js';
import greatestNumber from './greatest_number_exercise.js';

function assertEqual(x, y) {
  if (x === y) {
    console.log('.');
  } else {
    console.log('FAIL');
  }
}

function assertArrayEqual(x, y) {
  if (JSON.stringify(x) === JSON.stringify(y)) {
    console.log('.');
  } else {
    console.log('FAIL');
  }
}

// Bubble Sort
console.log('Bubble Sort');
assertArrayEqual(bubbleSort([]), []);
assertArrayEqual(bubbleSort([5]), [5]);
assertArrayEqual(bubbleSort([1, 5]), [1, 5]);
assertArrayEqual(bubbleSort([5, 1]), [1, 5]);
assertArrayEqual(bubbleSort([5, 3, 4, 2, 1]), [1, 2, 3, 4, 5]);
assertArrayEqual(bubbleSort([5, 4, 3, 2, 1]), [1, 2, 3, 4, 5]);
const array = [1, 9, 3, 4, 5, 10, 0];
assertArrayEqual(bubbleSort(array), [0, 1, 3, 4, 5, 9, 10]);

// # Duplicates #1
console.log('Duplicates #1');
assertEqual(hasDuplicateValue1([]), false);
assertEqual(hasDuplicateValue1([1]), false);
assertEqual(hasDuplicateValue1([1, 2, 3, 4]), false);
assertEqual(hasDuplicateValue1([1, 2, 2, 3]), true);
assertEqual(hasDuplicateValue1([1, 2, 3, 4, 1]), true);

// Duplicates #2
console.log('Duplicates #2');
assertEqual(hasDuplicateValue2([]), false);
assertEqual(hasDuplicateValue2([1]), false);
assertEqual(hasDuplicateValue2([1, 2, 3, 4]), false);
assertEqual(hasDuplicateValue2([1, 2, 2, 3]), true);
assertEqual(hasDuplicateValue2([1, 2, 3, 4, 1]), true);

// Duplicates #3
console.log('Duplicates #3');
assertEqual(hasDuplicateValue3([]), false);
assertEqual(hasDuplicateValue3([1]), false);
assertEqual(hasDuplicateValue3([1, 2, 3, 4]), false);
assertEqual(hasDuplicateValue3([1, 2, 2, 3]), true);
assertEqual(hasDuplicateValue3([1, 2, 3, 4, 1]), true);
assertEqual(hasDuplicateValue3([10, 2, 3, 4, 10]), true);
assertEqual(hasDuplicateValue3([0, 2, 3, 4, 0]), true);

// Duplicates #4
console.log('Duplicates #4');
assertEqual(hasDuplicateValue4([]), false);
assertEqual(hasDuplicateValue4([1]), false);
assertEqual(hasDuplicateValue4([1, 2, 3, 4]), false);
assertEqual(hasDuplicateValue4([1, 2, 2, 3]), true);
assertEqual(hasDuplicateValue4([1, 2, 3, 4, 1]), true);

// Greatest Product
console.log('Greatest Product');
assertEqual(greatestProduct([]), null);
assertEqual(greatestProduct([1]), null);
assertEqual(greatestProduct([1, 2]), 2);
assertEqual(greatestProduct([5, 2, 4, 1]), 20);
assertEqual(greatestProduct([5, 2, -4, 1]), 10);

// Greatest Number - Exercise
console.log('Greatest Number - Exercise');
assertEqual(greatestNumber([]), null);
assertEqual(greatestNumber([1]), 1);
assertEqual(greatestNumber([1, 3, 5]), 5);
assertEqual(greatestNumber([5, 3, 1]), 5);
assertEqual(greatestNumber([5, 3, 1, 9, 7, -4]), 9);

// Greatest Number - Solution
console.log('Greatest Number - Solution');
assertEqual(greatestNumber([]), null);
assertEqual(greatestNumber([1]), 1);
assertEqual(greatestNumber([1, 3, 5]), 5);
assertEqual(greatestNumber([5, 3, 1]), 5);
assertEqual(greatestNumber([5, 3, 1, 9, 7, -4]), 9);
