/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
import selectionSort from './selection_sort.js';
import { printNumbersVersionOne, printNumbersVersionTwo } from './print_numbers.js';
import doubleThenSum from './double_sum.js';
import multipleCases from './multicase.js';
import everyOther from './every_other.js';

function assertEqual(x, y) {
  if (x === y) {
    console.log('.');
  } else {
    console.log('FAIL');
  }
}

function assertArrayEqual(x, y) {
  if (JSON.stringify(x) === JSON.stringify(y)) {
    console.log('.');
  } else {
    console.log('FAIL');
  }
}

// Selection Sort
console.log('Selection Sort');
assertArrayEqual(selectionSort([]), []);
assertArrayEqual(selectionSort([5]), [5]);
assertArrayEqual(selectionSort([1, 5]), [1, 5]);
assertArrayEqual(selectionSort([5, 1]), [1, 5]);
assertArrayEqual(selectionSort([5, 3, 4, 2, 1]), [1, 2, 3, 4, 5]);
assertArrayEqual(selectionSort([5, 4, 3, 2, 1]), [1, 2, 3, 4, 5]);
const array = [1, 9, 3, 4, 5, 10, 0];
assertArrayEqual(selectionSort(array), [0, 1, 3, 4, 5, 9, 10]);

// Print numbers
console.log('Print numbers: Should print even numbers 2 - 10 twice');
printNumbersVersionOne(10);
printNumbersVersionTwo(10);

// Double sum
console.log('Double sum');
assertEqual(doubleThenSum([]), 0);
assertEqual(doubleThenSum([1, 4, 9]), 28);

// Multiple cases
console.log('Multiple cases');
multipleCases(['hElLo', 'gooDbYe']);

// Every other
console.log('Every other - should print 2 3 4 4 5 6');
everyOther([1, 2, 3]);
