/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
import insertionSort from './insertion_sort.js';
import { intersection as intersection1 } from './intersection1.js';
import { intersection as intersection2 } from './intersection2.js';
import twoSum from './two_sum.js';
import { containsX as containsX1 } from './contains_x.js';
import { containsX as containsX2 } from './contains_x_solution.js';

function assertEqual(x, y) {
  if (x === y) {
    console.log('.');
  } else {
    console.log('FAIL');
  }
}

function assertArrayEqual(x, y) {
  if (JSON.stringify(x) === JSON.stringify(y)) {
    console.log('.');
  } else {
    console.log('FAIL');
  }
}

// Insertion Sort
console.log('Insertion Sort');
assertArrayEqual(insertionSort([]), []);
assertArrayEqual(insertionSort([5]), [5]);
assertArrayEqual(insertionSort([1, 5]), [1, 5]);
assertArrayEqual(insertionSort([5, 1]), [1, 5]);
assertArrayEqual(insertionSort([5, 3, 4, 2, 1]), [1, 2, 3, 4, 5]);
assertArrayEqual(insertionSort([5, 4, 3, 2, 1]), [1, 2, 3, 4, 5]);
const array = [1, 9, 3, 4, 5, 10, 0];
assertArrayEqual(insertionSort(array), [0, 1, 3, 4, 5, 9, 10]);

// Intersecton 1
console.log('Intersecton 1');
assertArrayEqual(intersection1([3, 1, 4, 2], [4, 5, 3, 6]), [3, 4]);
assertArrayEqual(intersection1([3, 1, 4, 2], [5, 3, 6]), [3]);
assertArrayEqual(intersection1([], []), []);
assertArrayEqual(intersection1([], [1]), []);
assertArrayEqual(intersection1([1], []), []);
assertArrayEqual(intersection1([1, 2, 3], [4, 5, 6]), []);

// Intersecton 2
console.log('Intersecton 2');
assertArrayEqual(intersection2([3, 1, 4, 2], [4, 5, 3, 6]), [3, 4]);
assertArrayEqual(intersection2([3, 1, 4, 2], [5, 3, 6]), [3]);
assertArrayEqual(intersection2([], []), []);
assertArrayEqual(intersection2([], [1]), []);
assertArrayEqual(intersection2([1], []), []);
assertArrayEqual(intersection2([1, 2, 3], [4, 5, 6]), []);

// Two Sum
console.log('Two Sum');
assertEqual(twoSum([]), false);
assertEqual(twoSum([1]), false);
assertEqual(twoSum([1, 2, 3, 10]), false);
assertEqual(twoSum([1, 2, 3, 4]), false);
assertEqual(twoSum([1, 2, 3, 8]), true);
assertEqual(twoSum([1, 2, 3, 9]), true);

// Contains X - Exercise
console.log('Contains X - Exercise');
assertEqual(containsX1(''), false);
assertEqual(containsX1(' '), false);
assertEqual(containsX1('ABCDx'), false);
assertEqual(containsX1('xxxxx'), false);
assertEqual(containsX1('X'), true);
assertEqual(containsX1('ADSFXPODFO'), true);

// Contains X - Solution
console.log('Contains X - Solution');
assertEqual(containsX2(''), false);
assertEqual(containsX2(' '), false);
assertEqual(containsX2('ABCDx'), false);
assertEqual(containsX2('xxxxx'), false);
assertEqual(containsX2('X'), true);
assertEqual(containsX2('ADSFXPODFO'), true);
