/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
function merge(array1, array2) {
  const newArray = [];
  let array1Pointer = 0;
  let array2Pointer = 0;

  // Run the loop until we've reached end of both arrays:
  while (array1Pointer < array1.length || array2Pointer < array2.length) {
    // If we already reached the end of the first array,
    // add item from second array:
    if (array1Pointer >= array1.length) {
      newArray.push(array2[array2Pointer]);
      array2Pointer += 1;
    // If we already reached the end of the second array,
    // add item from first array:
    } else if (array2Pointer >= array2.length) {
      newArray.push(array1[array1Pointer]);
      array1Pointer += 1;
    // If the current number in first array is less than current
    // number in second array, add from first array:
    } else if (array1[array1Pointer] < array2[array2Pointer]) {
      newArray.push(array1[array1Pointer]);
      array1Pointer += 1;
    // If the current number in second array is less than or equal
    // to current number in first array, add from second array:
    } else {
      newArray.push(array2[array2Pointer]);
      array2Pointer += 1;
    }
  }

  return newArray;
}
export default merge;
