/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
import everyPassword from './password.js';
import averageOfEvenNumbers from './average_even.js';
import { wordBuilder as wordBuilder1 } from './word_builder_1.js';
import { wordBuilder as wordBuilder2 } from './word_builder_2.js';
import sample from './array_sample.js';
import averageCelsius from './celsius.js';
import markInventory from './labels.js';
import countOnes from './count_ones.js';
import isPalindrome from './palindrome.js';
import { twoNumberProducts as twoNumberProducts1 } from './products1.js';
import { twoNumberProducts as twoNumberProducts2 } from './products2.js';
import oneHundredSum from './exercise1.js';
import merge from './exercise2.js';
import findNeedle from './exercise3.js';
import largestProduct from './exercise4.js';
import pickResume from './exercise5.js';

function assertEqual(x, y) {
  if (x === y) {
    console.log('.');
  } else {
    console.log('FAIL');
  }
}

function assertArrayEqual(x, y) {
  if (JSON.stringify(x) === JSON.stringify(y)) {
    console.log('.');
  } else {
    console.log('FAIL');
  }
}

// Password cracker
console.log('Password cracker');
everyPassword(2);

// Average of even numbers
console.log('Average of even numbers');
assertEqual(averageOfEvenNumbers([1, 2, 3, 4, 5, 6]), 4);
assertEqual(averageOfEvenNumbers([1, 2, 3, 4, 5, 6, 8]), 5);
assertEqual(averageOfEvenNumbers([]), null);
assertEqual(averageOfEvenNumbers([1, 3, 5]), null);

// Word Builder 1
console.log('Word Builder 1');
const resultArray = [
  'ab', 'ac', 'ad', 'ba', 'bc', 'bd', 'ca',
  'cb', 'cd', 'da', 'db', 'dc'];
assertArrayEqual(wordBuilder1(['a', 'b', 'c', 'd']), resultArray);
assertArrayEqual(wordBuilder1([]), []);
assertArrayEqual(wordBuilder1(['a']), []);

// Word Builder 2
console.log('Word Builder 2');
const resultArray2 = [
  'abc', 'abd', 'acb', 'acd', 'adb', 'adc', 'bac', 'bad',
  'bca', 'bcd', 'bda', 'bdc', 'cab', 'cad', 'cba', 'cbd',
  'cda', 'cdb', 'dab', 'dac', 'dba', 'dbc', 'dca', 'dcb',
];
assertArrayEqual(wordBuilder2(['a', 'b', 'c', 'd']), resultArray2);
assertArrayEqual(wordBuilder2([]), []);
assertArrayEqual(wordBuilder2(['a']), []);

// Array sample
console.log('Array sample');
assertArrayEqual(sample([1, 2, 3, 4, 5]), [1, 3, 5]);
assertArrayEqual(sample([1, 2, 3, 4]), [1, 3, 4]);
assertArrayEqual(sample([1]), [1, 1, 1]);
assertArrayEqual(sample([]), null);

// Average Celsius reading
console.log('Average Celsius reading');
assertEqual(averageCelsius([20, 80, 45, 71]), 12.0);
assertEqual(averageCelsius([-40]), -40.0);
assertEqual(averageCelsius([]), null);

// Clothing labels
console.log('Clothing labels');
const array = [
  'Purple Shirt Size: 1',
  'Purple Shirt Size: 2',
  'Purple Shirt Size: 3',
  'Purple Shirt Size: 4',
  'Purple Shirt Size: 5',
  'Green Shirt Size: 1',
  'Green Shirt Size: 2',
  'Green Shirt Size: 3',
  'Green Shirt Size: 4',
  'Green Shirt Size: 5',
];
assertArrayEqual(markInventory(['Purple Shirt', 'Green Shirt']), array);
assertArrayEqual(markInventory([]), []);

// Count ones
console.log('Count ones');
const array1 = [
  [0, 1, 1, 1, 0],
  [0, 1, 0, 1, 0, 1],
  [1, 0],
];
assertEqual(countOnes(array1), 7);

// Palindrome
console.log('Palindrome');
assertEqual(isPalindrome(''), true);
assertEqual(isPalindrome('car'), false);
assertEqual(isPalindrome('o'), true);
assertEqual(isPalindrome('oo'), true);
assertEqual(isPalindrome('racecar'), true);

// Products 1
console.log('Products - Single Array');
const array2 = [2, 3, 4, 5, 6, 8, 10, 12, 15, 20];
assertArrayEqual(twoNumberProducts1([1, 2, 3, 4, 5]), array2);
assertArrayEqual(twoNumberProducts1([]), []);
assertArrayEqual(twoNumberProducts1([2]), []);

// Products 2
console.log('Products - Double Array');
const array3 = [10, 100, 1000, 20, 200, 2000, 30, 300, 3000];
assertArrayEqual(twoNumberProducts2([1, 2, 3], [10, 100, 1000]), array3);
assertArrayEqual(twoNumberProducts2([], []), []);
assertArrayEqual(twoNumberProducts2([1], []), []);
assertArrayEqual(twoNumberProducts2([], [1]), []);

// Exercise 1 - 100 Sum
console.log('Exercise 1 - 100 Sum');
assertEqual(oneHundredSum([1, 98, 3, 97, 2, 99]), true);
// Can only be true if there are an even amount of numbers:
assertEqual(oneHundredSum([1, 98, 3, 100, 97, 2, 99]), false);
assertEqual(oneHundredSum([1, 98, 3, 97, 2, 95]), false);
assertEqual(oneHundredSum([]), false);
assertEqual(oneHundredSum([1]), false);

// Exercise 2 - Merge
console.log('Exercise 2 - Merge');
assertArrayEqual(merge([1, 2, 3], [4, 5, 6]), [1, 2, 3, 4, 5, 6]);
assertArrayEqual(merge([1, 3, 5], [2, 4, 6]), [1, 2, 3, 4, 5, 6]);
assertArrayEqual(merge([2, 3, 6], [1, 4, 5]), [1, 2, 3, 4, 5, 6]);

// Exercise 3 - Needle in haystack
console.log('Exercise 3 - Needle in haystack');
assertEqual(findNeedle('abc', 'abcdefg'), true);
assertEqual(findNeedle('c', 'abcdefg'), true);
assertEqual(findNeedle('def', 'abcdefg'), true);
assertEqual(findNeedle('fg', 'abcdefg'), true);
assertEqual(findNeedle('g', 'abcdefg'), true);
assertEqual(findNeedle('gh', 'abcdefg'), false);
assertEqual(findNeedle('aa', 'abcdefg'), false);
assertEqual(findNeedle('ccd', 'abccdefg'), true);

// Exercise 4 - Largest product of 3
console.log('Exercise 4 - Largest product of 3');
assertEqual(largestProduct([]), null);
assertEqual(largestProduct([1]), null);
assertEqual(largestProduct([1, 2]), null);
assertEqual(largestProduct([1, 2, 3]), 6);
assertEqual(largestProduct([3, 2, 5, 1, 4]), 60);

// Exercise 5 - Resume picker
console.log('Exercise 5 - Resume picker');
assertEqual(pickResume([1, 2, 3, 4, 5, 6]), 2);
assertEqual(pickResume([1, 2, 3, 4, 5, 6, 7]), 2);
assertEqual(pickResume([1, 2, 3, 4, 5, 6, 7, 8, 9]), 3);
assertEqual(pickResume([1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11]), 3);
assertEqual(pickResume([]), null);
assertEqual(pickResume([1]), 1);
