/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
import { statusCodeMeaning as statusCodeMeaning1 } from './status_codes1.js';
import { statusCodeMeaning as statusCodeMeaning2 } from './status_codes2.js';
import { isSubset as isSubset1 } from './subset1.js';
import { isSubset as isSubset2 } from './subset2.js';
import getIntersection from './solution1.js';
import findDuplicate from './solution2.js';
import findMissingLetter from './solution3.js';
import firstNonDuplicate from './solution4.js';

function assertEqual(x, y) {
  if (x === y) {
    console.log('.');
  } else {
    console.log('FAIL');
  }
}

function assertArrayEqual(x, y) {
  if (JSON.stringify(x) === JSON.stringify(y)) {
    console.log('.');
  } else {
    console.log('FAIL');
  }
}

// Status Codes 1
console.log('Status codes 1');
assertEqual(statusCodeMeaning1(200), 'OK');
assertEqual(statusCodeMeaning1(301), 'Moved Permanently');
assertEqual(statusCodeMeaning1(401), 'Unauthorized');
assertEqual(statusCodeMeaning1(404), 'Not Found');
assertEqual(statusCodeMeaning1(500), 'Internal Server Error');

// Status Codes 2
console.log('Status codes 2');
assertEqual(statusCodeMeaning2(200), 'OK');
assertEqual(statusCodeMeaning2(301), 'Moved Permanently');
assertEqual(statusCodeMeaning2(401), 'Unauthorized');
assertEqual(statusCodeMeaning2(404), 'Not Found');
assertEqual(statusCodeMeaning2(500), 'Internal Server Error');

// Subset 1
console.log('Subset 1');
const array1 = ['a', 'b', 'c', 'd', 'e', 'f'];
let array2 = ['b', 'd', 'f'];
assertEqual(isSubset1(array1, array2), true);
array2 = ['b', 'd', 'h'];
assertEqual(isSubset1(array1, array2), false);
assertEqual(isSubset1([], []), true);
assertEqual(isSubset1(['a'], ['b', 'a']), true);

// Subset 2
console.log('Subset 2');
const array3 = ['a', 'b', 'c', 'd', 'e', 'f'];
let array4 = ['b', 'd', 'f'];
assertEqual(isSubset2(array3, array4), true);
array4 = ['b', 'd', 'h'];
assertEqual(isSubset2(array3, array4), false);
assertEqual(isSubset2([], []), true);
assertEqual(isSubset2(['a'], ['b', 'a']), true);

// Solution 1
console.log('Solution 1');
assertArrayEqual(getIntersection([1, 2, 3, 4, 5], [0, 2, 4, 6, 8]), [2, 4]);
assertArrayEqual(getIntersection([], []), []);
assertArrayEqual(getIntersection([1], [2]), []);

// Solution 2
console.log('Solution 2');
assertEqual(findDuplicate(['a', 'b', 'c', 'd', 'c', 'e', 'f']), 'c');
assertEqual(findDuplicate(['a', 'b', 'c', 'd', 'e', 'f']), null);
assertEqual(findDuplicate([]), null);

// Solution 3
console.log('Solution 3');
let string = 'the quick brown box jumps over a lazy dog';
assertEqual(findMissingLetter(string), 'f');
string = 'the quick brown fox jumps over a lazy dog';
assertEqual(findMissingLetter(string), null);

// Solution 4
console.log('Solution 4');
assertEqual(firstNonDuplicate('minimum'), 'n');
assertEqual(firstNonDuplicate('llamma'), null);
