/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
import Queue from './queue.js';

class PrintManager {
  constructor() {
    this.queue = new Queue();
  }

  queuePrintJob(document) {
    this.queue.enqueue(document);
  }

  run() {
    while (this.queue.read()) {
      this.printDocument(this.queue.dequeue());
    }
  }

  printDocument(document) {
    // Code to run the actual printer goes here.
    // For demo purposes, we'll print to the terminal:
    console.log(document);
  }
}
export default PrintManager;
