/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
import { countdown as countdown1 } from './countdown_1.js';
import { countdown as countdown3 } from './countdown_3.js';
import factorial from './factorial.js';
import { printSubdirectories as printSubdirectories1 } from './filesystem1.js';
import { printSubdirectories as printSubdirectories2 } from './filesystem2.js';
import { printSubdirectories as printSubdirectories3 } from './filesystem3.js';
import printEveryOther from './exercise_1.js';
import { factorial as factorial2 } from './exercise_2.js';
import sum from './solution_3.js';
import printAllItems from './solution_4.js';

function assertEqual(x, y) {
  if (x === y) {
    console.log('.');
  } else {
    console.log('FAIL');
  }
}

// Countdown 1
console.log('Countdown 1');
countdown1(10);
console.log('');

// Countdown 2 skipped because it's infinite recursion

// Countdown 3
console.log('Countdown 3');
countdown3(10);
console.log('');

// Factorial
console.log('Factorial');
assertEqual(factorial(5), 120);
assertEqual(factorial(1), 1);
assertEqual(factorial(0), 1);

// Filesystem 1
console.log('Filesystem 1'); // should print subdirectory_1, _2, _3
printSubdirectories1('.');

// Filesystem 2
console.log('Filesystem 2'); // should ALSO print subdirectory_1_1,  _1_2, _2_1
printSubdirectories2('.');

// Filesystem 3
console.log('Filesystem 3'); // should also print _2_1_1 and _2_1_2
printSubdirectories3('.');

// Exercise 1
console.log('Exercise 1');
printEveryOther(0, 10); // should print even numbers from 0 to 10

// Exercise 2
console.log('Exercise 2');
assertEqual(factorial2(9), 945);

// Exercise 3 skipped because of infinite recursion

// Exercise 4 is just an array

// Solution 3
console.log('Solution 3');
assertEqual(sum(1, 10), 55);
assertEqual(sum(1, 2), 3);

// Solution 4
console.log('Solution 4'); // Should print 1 to 33
const array = [1, 2, 3,
  [4, 5, 6], 7,
  [8, [9, 10, 11, [12, 13, 14]]],
  [15, 16, 17, 18, 19, [20, 21, 22,
    [23, 24, 25, [26, 27, 29]], 30, 31], 32], 33];

printAllItems(array);
