/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
import doubleArray from './double_array.js';
import { factorial as factorial1 } from './factorial1.js';
import { factorial as factorial2 } from './factorial2.js';
import sum from './array_sum.js';
import reverse from './reverse.js';
import { countX as countX1 } from './countx1.js';
import { countX as countX2 } from './countx2.js';
import { numberOfPaths as numberOfPaths1 } from './staircase1.js';
import { numberOfPaths as numberOfPaths2 } from './staircase2.js';
import anagramsOf from './anagrams.js';
import characterCount from './solution1.js';
import selectEven from './solution2.js';
import triangle from './solution3.js';
import indexOfX from './solution4.js';
import uniquePaths from './solution5.js';

function assertEqual(x, y) {
  if (x === y) {
    console.log('.');
  } else {
    console.log('FAIL');
  }
}

function assertArrayEqual(x, y) {
  if (JSON.stringify(x) === JSON.stringify(y)) {
    console.log('.');
  } else {
    console.log('FAIL');
  }
}

// Double array
console.log('Double array');
const array = [1, 2, 3, 4, 5];
doubleArray(array);
assertArrayEqual(array, [2, 4, 6, 8, 10]);

// // Factorial 1
console.log('Factorial 1');
assertEqual(factorial1(6), 720);

// Factorial 2
console.log('Factorial 2');
assertEqual(factorial2(6), 720);

// Array sum
console.log('Array sum');
assertEqual(sum([1, 2, 3, 4, 5]), 15);
assertEqual(sum([1]), 1);
assertEqual(sum([]), 0);

// Reverse string
console.log('Reverse string');
assertEqual(reverse('abcde'), 'edcba');
assertEqual(reverse('a'), 'a');
assertEqual(reverse(''), '');

// Count X 1  - Purposely not testing empty string
console.log('Count x 1');
assertEqual(countX1('fxsgxaxr'), 3);
assertEqual(countX1('fxsgxar'), 2);
assertEqual(countX1('fsgar'), 0);
assertEqual(countX1('x'), 1);

// Count x 2
console.log('Count x 2');
assertEqual(countX2('fxsgxaxr'), 3);
assertEqual(countX2('fxsgxar'), 2);
assertEqual(countX2('fsgar'), 0);
assertEqual(countX2('x'), 1);
assertEqual(countX2(''), 0);

// Staircase 1
console.log('Staircase 1');
assertEqual(numberOfPaths1(0), 0);
assertEqual(numberOfPaths1(1), 1);
assertEqual(numberOfPaths1(2), 2);
assertEqual(numberOfPaths1(3), 4);
assertEqual(numberOfPaths1(4), 7);

// Staircase 2   = the case of 0 should return 1 because it's 'rigged'
console.log('Staircase 2');
assertEqual(numberOfPaths2(0), 1);
assertEqual(numberOfPaths2(1), 1);
assertEqual(numberOfPaths2(2), 2);
assertEqual(numberOfPaths2(3), 4);
assertEqual(numberOfPaths2(4), 7);

// Anagrams
console.log('Anagrams');
const array2 = ['abc', 'bac', 'bca', 'acb', 'cab', 'cba'];
console.log(anagramsOf('abc'));
assertArrayEqual(anagramsOf('abc'), array2);

// Solution 1
console.log('Solution 1');
assertEqual(characterCount(['ab', 'c', 'def', 'ghij']), 10);

// Solution 2
console.log('Solution 2');
assertArrayEqual(selectEven([1, 2, 3, 7, 8, 0]), [2, 8, 0]);

// Solution 3
console.log('Solution 3');
assertEqual(triangle(7), 28);

// Solution 4
console.log('Solution 4');
assertEqual(indexOfX('abcdefghijklmnopqrstuvwxyz'), 23);

// Solution 5
console.log('Solution 5');
assertEqual(uniquePaths(3, 7), 28);
