/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
import { max as max1 } from './array_max1.js';
import { max as max2 } from './array_max2.js';
import { fib as fib1 } from './fib1.js';
import { fib as fib2 } from './fib2.js';
import { fib as fib3 } from './fib3.js';
import { addUntil100 as addUntil100Exercise } from './exercise1.js';
import { addUntil100 as addUntil100Solution } from './solution1.js';
import { golomb as golombExercise } from './exercise2.js';
import { golomb as golombSolution } from './solution2.js';
import { uniquePaths as uniquePathsExercise } from './exercise3.js';
import { uniquePaths as uniquePathsSolution } from './solution3.js';

function assertEqual(x, y) {
  if (x === y) {
    console.log('.');
  } else {
    console.log('FAIL');
  }
}

// Array max 1
console.log('Array max 1');
assertEqual(max1([4, 6, 0, 1, 3, 3, 5]), 6);
assertEqual(max1([]), null);

// Array max 2
console.log('Array max 2');
assertEqual(max2([4, 6, 0, 1, 3, 3, 5]), 6);
assertEqual(max2([]), null);

// Fibonacci 1
console.log('Fibonacci 1');
assertEqual(fib1(0), 0);
assertEqual(fib1(1), 1);
assertEqual(fib1(2), 1);
assertEqual(fib1(3), 2);
assertEqual(fib1(7), 13);

// Fibonacci 2
console.log('Fibonacci 2');
assertEqual(fib2(0), 0);
assertEqual(fib2(1), 1);
assertEqual(fib2(2), 1);
assertEqual(fib2(3), 2);
assertEqual(fib2(7), 13);

// Fibonacci 3
console.log('Fibonacci 3');
assertEqual(fib3(0), 0);
assertEqual(fib3(1), 1);
assertEqual(fib3(2), 1);
assertEqual(fib3(3), 2);
assertEqual(fib3(7), 13);

// Exercise 1
console.log('Exercise 1');
assertEqual(addUntil100Exercise([3, 6, 5, 11, 90]), 98);

// Solution 1
console.log('Solution 1');
assertEqual(addUntil100Solution([3, 6, 5, 11, 90]), 98);

// Exercise 2
console.log('Exercise 2');
assertEqual(golombExercise(1), 1);
assertEqual(golombExercise(2), 2);
assertEqual(golombExercise(5), 3);
assertEqual(golombExercise(30), 10);

// // Solution 2
console.log('Solution 2');
assertEqual(golombSolution(1), 1);
assertEqual(golombSolution(2), 2);
assertEqual(golombSolution(5), 3);
assertEqual(golombSolution(30), 10);

// Exercise 3
console.log('Exercise 3');
assertEqual(uniquePathsExercise(3, 7), 28);

// Solution 3
console.log('Solution 3');
assertEqual(uniquePathsSolution(3, 7), 28);
