/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
class SortableArray {
  constructor(array) {
    this.array = array;
  }

  partition(leftPointer, rightPointer) {
    const pivotIndex = rightPointer;
    const pivot = this.array[pivotIndex];

    rightPointer -= 1;

    while (true) {
      while (this.array[leftPointer] < pivot) {
        leftPointer += 1;
      }

      while (this.array[rightPointer] > pivot) {
        rightPointer -= 1;
      }

      if (leftPointer >= rightPointer) {
        break;
      } else {
        [this.array[leftPointer], this.array[rightPointer]] = 
          [this.array[rightPointer], this.array[leftPointer]];
        leftPointer += 1;
      }
    }

    [this.array[leftPointer], this.array[pivotIndex]] = 
      [this.array[pivotIndex], this.array[leftPointer]];

    return leftPointer;
  }

  quicksort(leftIndex, rightIndex) {
    if (rightIndex - leftIndex <= 0) {
      return;
    }

    const pivotIndex = this.partition(leftIndex, rightIndex);

    this.quicksort(leftIndex, pivotIndex - 1);

    this.quicksort(pivotIndex + 1, rightIndex);
  }

  quickselect(kthLowestValue, leftIndex, rightIndex) {
    if (rightIndex - leftIndex <= 0) {
      return this.array[leftIndex];
    }

    const pivotIndex = this.partition(leftIndex, rightIndex);

    if (kthLowestValue < pivotIndex) {
      return this.quickselect(kthLowestValue, leftIndex, pivotIndex - 1);
    } else if (kthLowestValue > pivotIndex) {
      return this.quickselect(kthLowestValue, pivotIndex + 1, rightIndex);
    } else {
      return this.array[pivotIndex];
    }
  }
}
export default SortableArray;
