/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
import SortableArray from './sortable_array.js';
import hasDuplicateValue from './duplicate.js';
import greatestProductOf3 from './solution1.js';
import { findMissingNumber as findMissingNumber1 } from './exercise2.js';
import { findMissingNumber as findMissingNumber2 } from './solution2.js';
import { max as max1 } from './solution3a.js';
import { max as max2 } from './solution3b.js';
import { max as max3 } from './solution3c.js';

function assertEqual(x, y) {
  if (x === y) {
    console.log('.');
  } else {
    console.log('FAIL');
  }
}

function assertArrayEqual(x, y) {
  if (JSON.stringify(x) === JSON.stringify(y)) {
    console.log('.');
  } else {
    console.log('FAIL');
  }
}

// // Partition
console.log('Partition');
let array = new SortableArray([7, 8, 1, 9, 0, 4]);
const leftPointer = array.partition(0, 5);
assertEqual(leftPointer, 2);
assertArrayEqual(array.array, [0, 1, 4, 9, 7, 8]);

// // Quicksort
console.log('Quicksort');
array = new SortableArray([7, 8, 1, 9, 0, 4]);
array.quicksort(0, 5);
assertArrayEqual(array.array, [0, 1, 4, 7, 8, 9]);

array = new SortableArray([12, 11, 10, 7, 8, 1, 9, 0, 4, 15, 3, 6, 5, 3, 4, 6,
  7, 7, 4, 3, 2, 1, 5, 3, 3, 3]);
array.quicksort(0, 25);
assertArrayEqual(array.array, [0, 1, 1, 2, 3, 3, 3, 3, 3, 3, 4,
  4, 4, 5, 5, 6, 6, 7, 7, 7, 8, 9, 10, 11, 12, 15]);

array = new SortableArray([]);
array.quicksort(0, 0);
assertArrayEqual(array.array, []);

array = new SortableArray([5]);
array.quicksort(0, 0);
assertArrayEqual(array.array, [5]);

array = new SortableArray([5, 2]);
array.quicksort(0, 1);
assertArrayEqual(array.array, [2, 5]);

// Quickselect
console.log('Quickselect');

array = new SortableArray([0, 50, 20, 10, 60, 30]);
assertArrayEqual(array.quickselect(1, 0, 5), 10);

array = new SortableArray([30]);
assertEqual(array.quickselect(0, 0, 0), 30);

// Duplicate value
console.log('Duplicate value');
assertEqual(hasDuplicateValue([5, 9, 3, 2, 4, 5, 6]), true);
assertEqual(hasDuplicateValue([9, 3, 2, 4, 5, 6]), false);
assertEqual(hasDuplicateValue([]), false);
assertEqual(hasDuplicateValue([1]), false);

// Solution 1
console.log('Solution 1');
assertEqual(greatestProductOf3([9, 3, 5, 1, 0, 4, 10]), 450);

// Exercise 2
console.log('Exercise 2');
assertEqual(findMissingNumber1([9, 3, 2, 5, 6, 7, 1, 0, 4, 10, 11]), 8);

// Solution 2
console.log('Solution 2');
assertEqual(findMissingNumber2([9, 3, 2, 5, 6, 7, 1, 0, 4, 10, 11]), 8);

// Solution 3a
console.log('Solution 3a');
assertEqual(max1([9, 3, 2, 5, 6, 7, 11, 0, 4]), 11);
assertEqual(max1([5]), 5);
assertEqual(max1([]), null);

// Solution 3b
console.log('Solution 3b');
assertEqual(max2([9, 3, 2, 5, 6, 7, 11, 0, 4]), 11);
assertEqual(max2([5]), 5);
assertEqual(max2([]), null);

// Solution 3c
console.log('Solution 3c');
assertEqual(max3([9, 3, 2, 5, 6, 7, 11, 0, 4]), 11);
assertEqual(max3([5]), 5);
assertEqual(max3([]), null);
