/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
import Node from './double_ended_node.js';

class DoublyLinkedList {
  constructor(firstNode=null, lastNode=null) {
    this.firstNode = firstNode;
    this.lastNode = lastNode;
  }
  append(value) {
    const newNode = new Node(value);

    if (!this.firstNode) {
      this.firstNode = newNode;
      this.lastNode = newNode;
    } else {
      newNode.previousNode = this.lastNode;
      this.lastNode.nextNode = newNode;
      this.lastNode = newNode;
    }
  }
  popHead() {
    const poppedNode = this.firstNode;
    this.firstNode = this.firstNode.nextNode;
    this.firstNode.previousNode = null;
    return poppedNode;
  }
  reversePrint() {
    let currentNode = this.lastNode;

    while (currentNode) {
      console.log(currentNode.data);
      currentNode = currentNode.previousNode;
    }
  }
}
export default DoublyLinkedList;
