/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
import DoublyLinkedList from './doubly_linked_list.js';

class Queue {
  constructor() {
    this.data = new DoublyLinkedList();
  }

  enqueue(element) {
    this.data.append(element);
  }

  dequeue() {
    const dequeuedNode = this.data.popHead();
    return dequeuedNode.data;
  }

  read() {
    if (!this.data.firstNode) { return null; }

    return this.data.firstNode.data;
  }
}
export default Queue;
