/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
function deleteNode(valueToDelete, node) {
  let currentNode = node;
  let parentOfCurrentNode;
  let childOfDeletedNode;
  let nodeToDelete;

  while (currentNode) {
    if (currentNode.value === valueToDelete) {
      nodeToDelete = currentNode;
      break;
    }

    parentOfCurrentNode = currentNode;
    if (valueToDelete < currentNode.value) {
      currentNode = currentNode.leftChild;
    } else if (valueToDelete > currentNode.value) {
      currentNode = currentNode.rightChild;
    }
  }

  if (!nodeToDelete) { return null; }

  if (nodeToDelete.leftChild && nodeToDelete.rightChild) {
    replaceWithSuccessorNode(nodeToDelete);
  } else { // deleted node has 0 or 1 children
    childOfDeletedNode = (nodeToDelete.leftChild || nodeToDelete.rightChild);

    if (!parentOfCurrentNode) {
      nodeToDelete.value = childOfDeletedNode.value;
      nodeToDelete.leftChild = childOfDeletedNode.leftChild;
      nodeToDelete.rightChild = childOfDeletedNode.rightChild;
    } else if (nodeToDelete === parentOfCurrentNode.leftChild) {
      parentOfCurrentNode.leftChild = childOfDeletedNode;
    } else if (nodeToDelete === parentOfCurrentNode.rightChild) {
      parentOfCurrentNode.rightChild = childOfDeletedNode;
    }
  }

  return nodeToDelete;
}

function replaceWithSuccessorNode(node) {
  let successorNode = node.rightChild;
  let parentOfSuccessorNode;

  if (!successorNode.leftChild) {
    node.value = successorNode.value;
    node.rightChild = successorNode.rightChild;
    return;
  }

  while (successorNode.leftChild) {
    parentOfSuccessorNode = successorNode;
    successorNode = successorNode.leftChild;
  }

  if (successorNode.rightChild) {
    parentOfSuccessorNode.leftChild = successorNode.rightChild;
  } else {
    parentOfSuccessorNode.leftChild = null;
  }

  node.value = successorNode.value;
  return successorNode;
}
export default deleteNode;
