/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
import Heap from './heap.js';

function assertEqual(x, y) {
  if (x === y) {
    console.log('.');
  } else {
    console.log('FAIL');
  }
}

function assertArrayEqual(x, y) {
  if (JSON.stringify(x) === JSON.stringify(y)) {
    console.log('.');
  } else {
    console.log('FAIL');
  }
}

// Insertion of root node
console.log('Insertion of root node');
let h = new Heap();
h.insert(100);
assertEqual(h.rootNode(), 100);

// Insertion of second node that is less than root
console.log('Insertion of second node that is less than root');
h.insert(88);
assertEqual(h.rootNode(), 100);

// Insertion of new node that is greater than root
console.log('Insertion of new node that is greater than root');
h.insert(101);
assertEqual(h.rootNode(), 101);

// Last node of multi-level heap
console.log('Last node of multi-level heap');
h = new Heap();
h.insert(100);
h.insert(88);
h.insert(25);
h.insert(87);
h.insert(16);
h.insert(8);
h.insert(12);
h.insert(86);
h.insert(50);
h.insert(2);
h.insert(15);
h.insert(3);
assertEqual(h.rootNode(), 100);
assertEqual(h.lastNode(), 3);

// Trickle up node
console.log('Trickle up node');
h.insert(40);
assertEqual(h.lastNode(), 8);

// Deletion
console.log('Deletion / Pop');
h = new Heap();
h.insert(100);
h.insert(88);
h.insert(25);
h.insert(87);
h.insert(16);
h.insert(8);
h.insert(12);
h.insert(86);
h.insert(50);
h.insert(2);
h.insert(15);
h.insert(3);
const poppedNode = h.pop();
assertEqual(poppedNode, 100);
assertEqual(h.rootNode(), 88);
assertEqual(h.lastNode(), 15);

// Another popping test to make sure heap is empty after
// popping all elements
h = new Heap();
h.insert(5);
h.insert(3);
h.insert(9);
h.insert(0);
h.insert(6);
let a = [];
a.push(h.pop());
a.push(h.pop());
a.push(h.pop());
a.push(h.pop());
a.push(h.pop());
assertArrayEqual(a, [9, 6, 5, 3, 0]);
assertArrayEqual(h.data, [])