/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
function dfs(vertex, searchValue, visitedVertices={}) {
  visitedVertices[vertex.value] = true;

  if (vertex.value === searchValue) { return vertex; }

  for (const adjacentVertex of vertex.adjacentVertices) {
    if (adjacentVertex.value === searchValue) {
      return adjacentVertex;
    }

    if (!visitedVertices[adjacentVertex.value]) {
      const vertexWeAreSearchingFor = 
        dfs(adjacentVertex, searchValue, visitedVertices);

      if (vertexWeAreSearchingFor) {
        return vertexWeAreSearchingFor;
      }
    }
  }

  return null;
}
export default dfs;
