/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
import Queue from './queue_implementation.js';

function findShortestPath(firstVertex, secondVertex, visitedVertices) {
  const queue = new Queue();
  const previousVertexTable = {};

  visitedVertices[firstVertex.value] = true;
  queue.enqueue(firstVertex);

  while (queue.read()) {
    const currentVertex = queue.dequeue();

    for (const adjacentVertex of currentVertex.adjacentVertices) {
      if (!visitedVertices[adjacentVertex.value]) {
        visitedVertices[adjacentVertex.value] = true;
        queue.enqueue(adjacentVertex);
        previousVertexTable[adjacentVertex.value] = currentVertex.value;
      }
    }
  }

  const shortestPath = [];
  let currentVertexValue = secondVertex.value;

  while (currentVertexValue !== firstVertex.value) {
    shortestPath.unshift(currentVertexValue);
    currentVertexValue = previousVertexTable[currentVertexValue];
  }

  shortestPath.unshift(firstVertex.value);

  return shortestPath;
}
export default findShortestPath;
