/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
import { makeUppercase as makeUppercase1 } from './uppercase1.js';
import { makeUppercase as makeUppercase2 } from './uppercase2.js';
import { hasDuplicateValue as hasDuplicateValue5 } from './duplicates5.js';
import { hasDuplicateValue as hasDuplicateValue6 } from './duplicates6.js';
import recurse from './recurse.js';
import loop from './loop.js';
import { reverse as reverse1 } from './exercise2.js';
import { reverse as reverse2 } from './solution3.js';
import { doubleArray1, doubleArray2, doubleArray3 } from './exercise4.js';

function assertEqual(x, y) {
  if (x === y) {
    console.log('.');
  } else {
    console.log('FAIL');
  }
}

function assertArrayEqual(x, y) {
  if (JSON.stringify(x) === JSON.stringify(y)) {
    console.log('.');
  } else {
    console.log('FAIL');
  }
}

// Uppercase 1
console.log('Uppercase 1');
assertArrayEqual(makeUppercase1(['a', 'b', 'c']), ['A', 'B', 'C']);

// Uppercase 2
console.log('Uppercase 2');
assertArrayEqual(makeUppercase2(['a', 'b', 'c']), ['A', 'B', 'C']);

// Duplicates 1 was already tested back in Chapter 4

// Duplicates 5
console.log('Duplicates 5');
assertEqual(hasDuplicateValue5([]), false);
assertEqual(hasDuplicateValue5([1]), false);
assertEqual(hasDuplicateValue5([1, 2, 3, 4]), false);
assertEqual(hasDuplicateValue5([1, 2, 2, 3]), true);
assertEqual(hasDuplicateValue5([1, 2, 3, 4, 1]), true);

// Duplicates 6
console.log('Duplicates 6');
assertEqual(hasDuplicateValue6([]), false);
assertEqual(hasDuplicateValue6([1]), false);
assertEqual(hasDuplicateValue6([1, 2, 3, 4]), false);
assertEqual(hasDuplicateValue6([1, 2, 2, 3]), true);
assertEqual(hasDuplicateValue6([1, 2, 3, 4, 1]), true);

// Recurse - should print from 5 down to 0
console.log('Recurse');
recurse(5);

// Loop - should print from 5 down to 0
console.log('Loop');
loop(5);

// Exercise 2
console.log('Exercise 2');
assertArrayEqual(reverse1([1, 3, 5, 7]), [7, 5, 3, 1]);

// Solution 3
console.log('Solution 3');
assertArrayEqual(reverse2([1, 3, 5, 7]), [7, 5, 3, 1]);
assertArrayEqual(reverse2([1, 3, 5, 7, 9]), [9, 7, 5, 3, 1]);

// Exercise 4
console.log('Exercise 4');
assertArrayEqual(doubleArray1([5, 4, 3, 2, 1]), [10, 8, 6, 4, 2]);
assertArrayEqual(doubleArray2([5, 4, 3, 2, 1]), [10, 8, 6, 4, 2]);
assertArrayEqual(doubleArray3([5, 4, 3, 2, 1]), [10, 8, 6, 4, 2]);
