/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
const objectsEqual = (o1, o2) => Object.keys(o1).length
  === Object.keys(o2).length && Object.keys(o1).every((p) => o1[p] === o2[p]);

function areAnagrams(firstString, secondString) {
  const firstWordHashTable = {};
  const secondWordHashTable = {};

  for (const char of firstString) {
    if (firstWordHashTable[char]) {
      firstWordHashTable[char] += 1;
    } else {
      firstWordHashTable[char] = 1;
    }
  }

  for (const char of secondString) {
    if (secondWordHashTable[char]) {
      secondWordHashTable[char] += 1;
    } else {
      secondWordHashTable[char] = 1;
    }
  }

  return objectsEqual(firstWordHashTable, secondWordHashTable);
}
export { areAnagrams };
