/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
function longestSequenceLength(array) {
  const hashTable = {};
  let greatestSequenceLength = 0;

  for (const number of array) {
    hashTable[number] = true;
  }

  for (const number of array) {
    if (!hashTable[number - 1]) {
      let currentSequenceLength = 1;
      let currentNumber = number;

      while (hashTable[currentNumber + 1]) {
        currentNumber += 1;
        currentSequenceLength += 1;

        if (currentSequenceLength > greatestSequenceLength) {
          greatestSequenceLength = currentSequenceLength;
        }
      }
    }
  }

  return greatestSequenceLength;
}
export default longestSequenceLength;
