/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
function sumSwap(array1, array2) {
  const hashTable = {};
  let sum1 = 0;
  let sum2 = 0;

  for (const [index, num] of array1.entries()) {
    sum1 += num;
    hashTable[num] = index;
  }

  for (const num of array2) {
    sum2 += num;
  }

  // If the input consists of integers and the difference
  // between the two sums are odd, it's impossible to find
  // an integer smack in the middle, so no swap is possible:
  if (Math.abs((sum1 - sum2) % 2) === 1) {
    return null;
  }

  const shiftAmount = Math.floor((sum1 - sum2) / 2);

  for (const [index, num] of array2.entries()) {
    if (hashTable[num + shiftAmount] || hashTable[num + shiftAmount] === 0) {
      return [hashTable[num + shiftAmount], index];
    }
  }

  return null;
}
export default sumSwap;
