/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
import { connectBooksWithAuthors as connectBooksWithAuthors1 } from './books_authors1.js';
import { connectBooksWithAuthors as connectBooksWithAuthors2 } from './books_authors2.js';
import { twoSum as twoSum1 } from './two_sum1.js';
import { twoSum as twoSum2 } from './two_sum2.js';
import { gameWinner as gameWinner1 } from './coin_game1.js';
import { gameWinner as gameWinner2 } from './coin_game2.js';
import sumSwap from './sum_swap.js';
import max from './array_max.js';
import maxSum from './largest_subsection.js';
import isIncreasingTriplet from './stocks.js';
import { areAnagrams as areAnagrams1 } from './anagrams1.js';
import { areAnagrams as areAnagrams2 } from './anagrams2.js';
import groupSort from './group_sort.js';
import findMultisportAthletes from './solution1.js';
import findMissingNumber from './solution2.js';
import findGreatestProfit from './solution3.js';
import greatestProduct from './solution4.js';
import sortTemperatures from './solution5.js';
import longestSequenceLength from './solution6.js';

function assertEqual(x, y) {
  if (x === y) {
    console.log('.');
  } else {
    console.log('FAIL');
  }
}

function assertArrayEqual(x, y) {
  if (JSON.stringify(x) === JSON.stringify(y)) {
    console.log('.');
  } else {
    console.log('FAIL');
  }
}

// For testing books with authors:
const objectsEqual = (o1, o2) => Object.keys(o1).length
  === Object.keys(o2).length && Object.keys(o1).every((p) => o1[p] === o2[p]);
const arraysEqual = (a1, a2) => a1.length === a2.length
  && a1.every((o, idx) => objectsEqual(o, a2[idx]));

// Books with authors //1
console.log('Books with authors 1');

const authors = [
  { authorId: 1, name: 'Virginia Woolf' },
  { authorId: 2, name: 'Leo Tolstoy' },
  { authorId: 3, name: 'Dr. Seuss' },
  { authorId: 4, name: 'J. K. Rowling' },
  { authorId: 5, name: 'Mark Twain' },
];

const books = [
  { authorId: 3, title: 'Hop on Pop' },
  { authorId: 1, title: 'Mrs. Dalloway' },
  { authorId: 4, title: 'Harry Potter and the Sorcerers Stone' },
  { authorId: 1, title: 'To the Lighthouse' },
  { authorId: 2, title: 'Anna Karenina' },
  { authorId: 5, title: 'The Adventures of Tom Sawyer' },
  { authorId: 3, title: 'The Cat in the Hat' },
  { authorId: 2, title: 'War and Peace' },
  { authorId: 3, title: 'Green Eggs and Ham' },
  { authorId: 5, title: 'The Adventures of Huckleberry Finn' },
];

const correctResult = [
  { author: 'Dr. Seuss', title: 'Hop on Pop' },
  { author: 'Virginia Woolf', title: 'Mrs. Dalloway' },
  { author: 'J. K. Rowling', title: 'Harry Potter and the Sorcerers Stone' },
  { author: 'Virginia Woolf', title: 'To the Lighthouse' },
  { author: 'Leo Tolstoy', title: 'Anna Karenina' },
  { author: 'Mark Twain', title: 'The Adventures of Tom Sawyer' },
  { author: 'Dr. Seuss', title: 'The Cat in the Hat' },
  { author: 'Leo Tolstoy', title: 'War and Peace' },
  { author: 'Dr. Seuss', title: 'Green Eggs and Ham' },
  { author: 'Mark Twain', title: 'The Adventures of Huckleberry Finn' },
];

assertEqual(arraysEqual(connectBooksWithAuthors1(books, authors), correctResult), true);

// Books with authors //2
console.log('Books with authors 2');
assertEqual(arraysEqual(connectBooksWithAuthors2(books, authors), correctResult), true);

// Two Sum 1
console.log('Two Sum 1');
assertEqual(twoSum1([2, 0, 4, 1, 7, 9]), true);
assertEqual(twoSum1([2, 0, 4, 5, 3, 9]), false);
assertEqual(twoSum1([5, 5]), true);
assertEqual(twoSum1([5]), false);

// Two Sum 2
console.log('Two Sum 2');
assertEqual(twoSum2([2, 0, 4, 1, 7, 9]), true);
assertEqual(twoSum2([2, 0, 4, 5, 3, 9]), false);
assertEqual(twoSum2([5, 5]), true);
assertEqual(twoSum2([5]), false);

// Coin game 1
console.log('Coin game 1');
assertEqual(gameWinner1(1), 'them');
assertEqual(gameWinner1(2), 'you');
assertEqual(gameWinner1(3), 'you');
assertEqual(gameWinner1(4), 'them');
assertEqual(gameWinner1(9), 'you');
assertEqual(gameWinner1(10), 'them');

// Coin game 2
console.log('Coin game 2');
assertEqual(gameWinner2(1), 'them');
assertEqual(gameWinner2(2), 'you');
assertEqual(gameWinner2(3), 'you');
assertEqual(gameWinner2(4), 'them');
assertEqual(gameWinner2(9), 'you');
assertEqual(gameWinner2(10), 'them');

// Sum swap
console.log('Sum swap');
assertArrayEqual(sumSwap([5, 3, 2, 9, 1], [1, 12, 5]), [2, 0]);
assertArrayEqual(sumSwap([5, 3, 3, 7], [4, 1, 1, 6]), [3, 0]);
assertEqual(sumSwap([5, 3, 3, 6], [4, 1, 1, 6]), null);
assertArrayEqual(sumSwap([1, 2, 3, 4, 5], [6, 7, 8]), [2, 0]);
assertArrayEqual(sumSwap([10, 15, 20], [5, 30]), [0, 0]);
assertEqual(sumSwap([5, 3, 1, 9, 0], [2, 12, 5]), null);
assertEqual(sumSwap([10], [5]), null);
assertEqual(sumSwap([], []), null);
assertEqual(sumSwap([], [5]), null);
assertEqual(sumSwap([10], []), null);

// Array max
console.log('Array max');
assertEqual(max([5, 8, 2, 0, 1]), 8);
assertEqual(max([]), null);
assertEqual(max([1]), 1);

// Largest subsection sum
console.log('Largest subsection sum');
assertEqual(maxSum([3, -4, 4, -3, 5, -9]), 6);
assertEqual(maxSum([1, 1, 0, -3, 5]), 5);
assertEqual(maxSum([5, -2, 3, -8, 4]), 6);
assertEqual(maxSum([2, -3, 1, 2, -1]), 3);
assertEqual(maxSum([5, -8, 2, 1, 0]), 5);

// Stock predictions
console.log('Stock predictions');
assertEqual(isIncreasingTriplet([22, 25, 21, 18, 19.6, 17, 16, 20.5]), true);
assertEqual(isIncreasingTriplet([5, 2, 8, 4, 3, 7]), true);
assertEqual(isIncreasingTriplet([8, 9, 7, 10]), true);
assertEqual(isIncreasingTriplet([50, 51.25, 48.4, 49, 47.2, 48, 46.9]), false);

// Anagrams 1
console.log('Anagrams 1');
assertEqual(areAnagrams1('a', 'a'), true);
assertEqual(areAnagrams1('enraged', 'angered'), true);
assertEqual(areAnagrams1('night', 'thing'), true);
assertEqual(areAnagrams1('nigh', 'thing'), false);
assertEqual(areAnagrams1('think', 'thing'), false);

// Anagrams 2
console.log('Anagrams 2');
assertEqual(areAnagrams2('a', 'a'), true);
assertEqual(areAnagrams2('enraged', 'angered'), true);
assertEqual(areAnagrams2('night', 'thing'), true);
assertEqual(areAnagrams2('nigh', 'thing'), false);
assertEqual(areAnagrams2('think', 'thing'), false);

// Group sorting
console.log('Group sorting');
assertArrayEqual(groupSort(['a', 'c', 'd', 'b', 'b', 'c', 'a', 'd', 'c', 'b', 'a', 'd']), ['a', 'a', 'a', 'c', 'c', 'c', 'd', 'd', 'd', 'b', 'b', 'b']);

// Solution 1
console.log('Solution 1');
const basketballPlayers = [
  { firstName: 'Jill', lastName: 'Huang', team: 'Gators' },
  { firstName: 'Janko', lastName: 'Barton', team: 'Sharks' },
  { firstName: 'Wanda', lastName: 'Vakulskas', team: 'Sharks' },
  { firstName: 'Jill', lastName: 'Moloney', team: 'Gators' },
  { firstName: 'Luuk', lastName: 'Watkins', team: 'Gators' },
];

const footballPlayers = [
  { firstName: 'Hanzla', lastName: 'Radosti', team: '32ers' },
  { firstName: 'Tina', lastName: 'Watkins', team: 'Barleycorns' },
  { firstName: 'Alex', lastName: 'Patel', team: '32ers' },
  { firstName: 'Jill', lastName: 'Huang', team: 'Barleycorns' },
  { firstName: 'Wanda', lastName: 'Vakulskas', team: 'Barleycorns' },
];

assertArrayEqual(findMultisportAthletes(basketballPlayers, footballPlayers), ['Jill Huang', 'Wanda Vakulskas']);

// Solution 2
console.log('Solution 2');
assertEqual(findMissingNumber([2, 3, 0, 6, 1, 5]), 4);
assertEqual(findMissingNumber([8, 2, 3, 9, 4, 7, 5, 0, 6]), 1);

// Solution 3
console.log('Solution 3');
assertEqual(findGreatestProfit([10, 7, 5, 8, 11, 2, 6]), 6);

// Solution 4
console.log('Solution 4');
assertEqual(greatestProduct([5, -10, -6, 9, 4]), 60);

// Solution 5
console.log('Solution 5');
assertArrayEqual(
  sortTemperatures([98, 99, 95, 105, 104, 98, 101, 99, 100, 97]),
  [95, 97, 98, 98, 99, 99, 100, 101, 104, 105],
);

// Solution 6
console.log('Solution 6');
assertEqual(longestSequenceLength([10, 5, 12, 3, 55, 30, 4, 11, 2]), 4);
assertEqual(longestSequenceLength([19, 13, 15, 12, 18, 14, 17, 11]), 5);
