/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
'use strict';

var define = require('define-properties');

var getPolyfill = require('./polyfill');

module.exports = function shimArrayBufferSlice() {
	if (typeof ArrayBuffer === 'function') {
		var polyfill = getPolyfill();
		define(
			ArrayBuffer.prototype,
			{ slice: polyfill },
			{ slice: function () { return ArrayBuffer.prototype.slice !== polyfill; } }
		);
	}

	return polyfill;
};
