/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
'use strict';

var index = require('../');
var test = require('tape');
var runTests = require('./tests');

test('as a function', function (t) {
	t.test('ArrayBuffer support', { skip: typeof ArrayBuffer === 'undefined' }, function (st) {
		st.test('bad array/this value', function (s2t) {
			s2t['throws'](function () { index(undefined); }, TypeError, 'undefined is not an object');
			s2t['throws'](function () { index(null); }, TypeError, 'null is not an object');
			s2t.end();
		});

		runTests(index, st);

		st.end();
	});

	t.test('no ArrayBuffer support', { skip: typeof ArrayBuffer !== 'undefined' }, function (st) {
		st['throws'](
			function () { index({}); },
			SyntaxError,
			'ArrayBuffer is not supported'
		);
	});

	t.end();
});
