/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
'use strict';

var test = require('tape');
var isArray = require('isarray');
var every = require('array.prototype.every');

var availableTypedArrays = require('../');

test('available typed arrays', function (t) {
	t.equal(typeof availableTypedArrays, 'function', 'is a function');

	var arrays = availableTypedArrays();
	t.equal(isArray(arrays), true, 'returns an array');

	t.equal(every(arrays, function (array) { return typeof array === 'string'; }), true, 'contains only strings');

	t.end();
});
