/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
'use strict';

var KeyForSymbol = require('./KeyForSymbol');
var Type = require('./Type');

// https://262.ecma-international.org/14.0/#sec-canbeheldweakly

module.exports = function CanBeHeldWeakly(v) {
	if (Type(v) === 'Object') {
		return true; // step 1
	}
	if (Type(v) === 'Symbol' && typeof KeyForSymbol(v) === 'undefined') {
		return true; // step 2
	}
	return false; // step 3
};
