/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
/* eslint no-restricted-syntax: 0, no-with: 0, strict: 0 */

var test = require('tape');

var shimUnscopables = require('../');

test('`with` statement', { skip: typeof Symbol !== 'function' || !Symbol.unscopables }, function (t) {
	var entries;
	var concat;
	with ([]) {
		t.equal(concat, Array.prototype.concat, 'concat is dynamically bound');
		t.notEqual(entries, Array.prototype.entries, 'entries is not dynamically bound');
	}

	var obj = {
		foo: 1,
		bar: 2
	};
	var foo;
	var bar;
	obj[Symbol.unscopables] = { foo: true };
	with (obj) {
		t.equal(foo, undefined);
		t.equal(bar, obj.bar);
	}

	shimUnscopables('concat');

	with ([]) {
		t.notEqual(concat, Array.prototype.concat, 'concat is no longer dynamically bound');
		t.notEqual(entries, Array.prototype.entries, 'entries is still not dynamically bound');
	}

	t.end();
});
