/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
"use strict";

module.exports = function(it) {
    const { pluginId, plugins } = it;

    let result = `ESLint couldn't determine the plugin "${pluginId}" uniquely.
`;

    for (const { filePath, importerName } of plugins) {
        result += `
- ${filePath} (loaded in "${importerName}")`;
    }

    result += `

Please remove the "plugins" setting from either config or remove either plugin installation.

If you still can't figure out the problem, please stop by https://eslint.org/chat/help to chat with the team.
`;

    return result;
};
