/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
'use strict';

var getName = require('../');
var test = require('tape');
var runTests = require('./tests');

test('as a function', function (t) {
	t.test('non-functions', function (st) {
		st['throws'](function () { getName(); }, TypeError, 'undefined is not a function');
		st['throws'](function () { getName(null); }, TypeError, 'null is not a function');
		st['throws'](function () { getName(true); }, TypeError, 'true is not a function');
		st['throws'](function () { getName(false); }, TypeError, 'false is not a function');
		st['throws'](function () { getName('foo'); }, TypeError, '"foo" is not a function');
		st['throws'](function () { getName([]); }, TypeError, '[] is not a function');
		st['throws'](function () { getName({}); }, TypeError, '{} is not a function');
		st['throws'](function () { getName(/a/g); }, TypeError, '/a/g is not a function');
		st.end();
	});

	runTests(getName, t);

	t.end();
});
