/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
'use strict';

require('../auto');

var test = require('tape');
var supportsDescriptors = require('define-properties').supportsDescriptors;
var isEnumerable = Object.prototype.propertyIsEnumerable;

var runTests = require('./tests');

test('shimmed', function (t) {
	t.test('enumerability', { skip: !supportsDescriptors }, function (et) {
		et.equal(false, isEnumerable.call(Function.prototype, 'name'), 'Function#name is not enumerable');
		et.equal(false, isEnumerable.call(function foo() {}, 'name'), 'a function’s name is not enumerable');
		et.end();
	});

	runTests(function (fn) { return fn.name; }, t);

	t.end();
});
