/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
'use strict';

var test = require('tape');
var inspect = require('object-inspect');
var forEach = require('for-each');

var isWeakRef = require('..');

test('isWeakRef', function (t) {
	t.equal(typeof isWeakRef, 'function', 'is a function');

	var nonWeakRefs = [undefined, null, true, false, 42, 0, Infinity, NaN, /a/g, function () {}, {}, []];
	forEach(nonWeakRefs, function (nonWeakRef) {
		t.equal(isWeakRef(nonWeakRef), false, inspect(nonWeakRef) + ' is not a WeakRef');
	});

	t.test('actual WeakRefs', { skip: typeof WeakRef === 'undefined' }, function (st) {
		var ref = new WeakRef({});

		st.equal(isWeakRef(ref), true, inspect(ref) + ' is a WeakRef');

		st.end();
	});

	t.end();
});
