/***
 * Excerpted from "A Common-Sense Guide to Data Structures and Algorithms, JavaScript Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/jwjavascript for more book information.
***/
'use strict';

var test = require('tape');
var parse = require('../');

test('long opts', function (t) {
	t.deepEqual(
		parse(['--bool']),
		{ bool: true, _: [] },
		'long boolean'
	);
	t.deepEqual(
		parse(['--pow', 'xixxle']),
		{ pow: 'xixxle', _: [] },
		'long capture sp'
	);
	t.deepEqual(
		parse(['--pow=xixxle']),
		{ pow: 'xixxle', _: [] },
		'long capture eq'
	);
	t.deepEqual(
		parse(['--host', 'localhost', '--port', '555']),
		{ host: 'localhost', port: 555, _: [] },
		'long captures sp'
	);
	t.deepEqual(
		parse(['--host=localhost', '--port=555']),
		{ host: 'localhost', port: 555, _: [] },
		'long captures eq'
	);
	t.end();
});
